<?php
/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2006 m3 Media Services Limited                         |
| For contact details, see: http://www.m3.net/                              |
|                                                                           |
| Copyright (c) 2000-2003 the phpAdsNew developers                          |
| For contact details, see: http://www.phpadsnew.com/                       |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: settings-defaults.php 4701 2006-04-18 09:10:21Z matteo@beccati.com $
*/

// Require the initialisation file
require_once '../../init.php';

// Required files
require_once MAX_PATH . '/lib/max/Admin/Preferences.php';
require_once MAX_PATH . '/lib/max/Admin/Redirect.php';
require_once MAX_PATH . '/www/admin/lib-settings.inc.php';
require_once MAX_PATH . '/www/admin/lib-statistics.inc.php';

// Security check
phpAds_checkAccess(phpAds_Admin + phpAds_Agency + phpAds_Client + phpAds_Affiliate);

$errormessage = array();

//define errors and informations
define('MAX_ERROR_RECORD_LENGTH_TO_BIG',    $GLOBALS['strRecordLengthToBig']);
define('MAX_ERROR_RECORD_NON_INT',          $GLOBALS['strRecordNonInt']);
define('MAX_ERROR_RECORD_WAS_NOT_INSERTED', $GLOBALS['strRecordWasNotInserted']);
define('MAX_ERROR_WRONG_COLUMN_PART1',      $GLOBALS['strWrongColumnPart1']);
define('MAX_ERROR_WRONG_COLUMN_PART2',      $GLOBALS['strWrongColumnPart2']);
define('MAX_ERROR_MISSING_COLUMN_PART1',    $GLOBALS['strMissingColumnPart1']);
define('MAX_ERROR_MISSING_COLUMN_PART2',    $GLOBALS['strMissingColumnPart2']);
define('MAX_ERROR_YOU_HAVE_NO_TRACKERS',    $GLOBALS['strYouHaneNoTrackers']);
define('MAX_ERROR_INSERT_ERROR_PART1',      $GLOBALS['strInsertErrorPart1']);
define('MAX_ERROR_INSERT_ERROR_PART2',      $GLOBALS['strInsertErrorPart2']);
define('MAX_ERROR_DUPLICATED_VALUE',        $GLOBALS['strDuplicatedValue']);
define('MAX_INFO_INSERT_CORRECT',           $GLOBALS['strInsertCorrect']);
define('MAX_INFO_REUPLOAD_CSV_FILE',        $GLOBALS['strReuploadCsvFile']);
define('MAX_INFO_CONFIRM_UPLOAD',           $GLOBALS['strConfirmUpload']);
define('MAX_INFO_IMPRESSION',               $GLOBALS['strView']);
define('MAX_INFO_CLICK',                    $GLOBALS['strClick']);
define('MAX_INFO_ARRIVAL',                  $GLOBALS['strArrival']);
define('MAX_INFO_MANUAL',                   $GLOBALS['strManual']);
define('MAX_INFO_COUNTRY',                  $GLOBALS['strIncludeCountryInfo']);
define('MAX_INFO_BROWSER',                  $GLOBALS['strIncludeBrowserInfo']);
define('MAX_INFO_OS',                       $GLOBALS['strIncludeOSInfo']);
define('MAX_INFO_LOADED_RECORDS',           $GLOBALS['strLoadedRecords']);
define('MAX_INFO_BROKEN_RECORDS',           $GLOBALS['strBrokenRecords']);
define('MAX_ERROR_WRONG_DATE_FORMAT',       $GLOBALS['strWrongDateFormat']);

//seting default values for select fields if exist
if(isset($_POST['clients']) && $_POST['clients'] != '') {
    $GLOBALS['_MAX']['PREF']['clients'] =$_POST['clients'];
}
if(isset($_POST['campaigns']) && $_POST['campaigns'] != '') {
    $GLOBALS['_MAX']['PREF']['campaigns'] =$_POST['campaigns'];
}
if(isset($_POST['tracker']) && $_POST['tracker'] != '') {
    $GLOBALS['_MAX']['PREF']['tracker'] =$_POST['tracker'];
}
if(isset($_POST['connection_status']) && $_POST['connection_status'] != '') {
    $GLOBALS['_MAX']['PREF']['connection_status'] =$_POST['connection_status'];
}
if(isset($_POST['connection_type']) && $_POST['connection_type'] != '') {
    $GLOBALS['_MAX']['PREF']['connection_type'] =$_POST['connection_type'];
}


//creating conversion type list
$defaultConversionTypeList[MAX_CONNECTION_MANUAL] = MAX_INFO_MANUAL;
$defaultConversionTypeList[MAX_CONNECTION_AD_IMPRESSION] = MAX_INFO_IMPRESSION;
$defaultConversionTypeList[MAX_CONNECTION_AD_CLICK] = MAX_INFO_CLICK;
$defaultConversionTypeList[MAX_CONNECTION_AD_ARRIVAL] = MAX_INFO_ARRIVAL;


//creating conversion status list
$defaultConversionStatusList[MAX_CONNECTION_STATUS_APPROVED] = $GLOBALS[$GLOBALS['_MAX']['STATUSES'][MAX_CONNECTION_STATUS_APPROVED]];
$defaultConversionStatusList[MAX_CONNECTION_STATUS_IGNORE] = $GLOBALS[$GLOBALS['_MAX']['STATUSES'][MAX_CONNECTION_STATUS_IGNORE]];
$defaultConversionStatusList[MAX_CONNECTION_STATUS_PENDING] = $GLOBALS[$GLOBALS['_MAX']['STATUSES'][MAX_CONNECTION_STATUS_PENDING]];
$defaultConversionStatusList[MAX_CONNECTION_STATUS_ONHOLD] = $GLOBALS[$GLOBALS['_MAX']['STATUSES'][MAX_CONNECTION_STATUS_ONHOLD]];
$defaultConversionStatusList[MAX_CONNECTION_STATUS_DISAPPROVED] = $GLOBALS[$GLOBALS['_MAX']['STATUSES'][MAX_CONNECTION_STATUS_DISAPPROVED]];
$defaultConversionStatusList[MAX_CONNECTION_STATUS_DUPLICATE] = $GLOBALS[$GLOBALS['_MAX']['STATUSES'][MAX_CONNECTION_STATUS_DUPLICATE]];


/**
 * Function creates file stream to download
 * @param string $stream  data for file
 * @param string $filename
 * @param string $mimetype
 * @return boolean 
 */
function downloadStream($stream, $filename, $mimetype) {

    $status = 0;
    $size = strlen($stream);
    if ($size > 0) {
        if(isset($_SERVER['HTTP_USER_AGENT']) && preg_match("/MSIE/", $_SERVER['HTTP_USER_AGENT'])) {
            ini_set( 'zlib.output_compression','Off' );
        }

        header ('Content-type: ' . $mimetype);
        header ('Content-Disposition: attachment; filename="' . $filename . '"');
        header ('Expires: '.gmdate("D, d M Y H:i:s", mktime(date("H")+2, date("i"), date("s"), date("m"), date("d"), date("Y"))).' GMT');
        header ('Accept-Ranges: bytes');
        header ("Cache-control: private");                 
        header ('Pragma: private');

        if(isset($_SERVER['HTTP_RANGE'])) {
            list($a, $range) = explode("=",$_SERVER['HTTP_RANGE']);
            //if yes, download missing part
            str_replace($range, "-", $range);
            $size2 = $size-1;
            $new_length = $size2-$range;
            header("HTTP/1.1 206 Partial Content");
            header("Content-Length: $new_length");
            header("Content-Range: bytes $range$size2/$size");
        } else { 
            $size2=$size-1;
            header("Content-Range: bytes 0-$size2/$size");
            header("Content-Length: ".$size);
        }
  
        // Dump the content.
        echo $stream;
        $status = 1;
    }
    return($status);
}



/**
 * Function checks if value is of correct type
 * @param string $value  for testing
 * @param string $pattern
 * @return string 'ok' / error message 
 */
function validateCsvData($value, $pattern) {
    $recordType = explode("(", $pattern);
    $recordType = $recordType[0];

    switch($recordType) {
    case 'varchar';
        $recordType = 'string';
        break;
    case 'bigint';
        $recordType = 'numeric';
        break;
    case 'datetime';
        $recordType = 'datetime';
        break;
    case 'int';
        $recordType = 'numeric';
        break;
    case 'text';
        $recordType = 'string';
        break;
    case 'char';
        $recordType = 'string';
        break;
    default;
        $recordType = 'string';
        break;
    }
    if($recordType == 'string') {
        preg_match('/\((.*?)\)/', $pattern, $res);
        if($res[1] != '' && strlen($value) > $res[1]) {
            return MAX_ERROR_RECORD_LENGTH_TO_BIG;
        }

        if(is_string($value)) {
            return 'ok';
        }
    }

    if($recordType == 'datetime')
    {
            return 'datetime';
    }

    if($recordType == 'numeric') {
        preg_match('/\((.*?)\)/', $pattern, $res);

        if($res[1] != '' && strlen($value) > $res[1]) {
            return MAX_ERROR_RECORD_LENGTH_TO_BIG;
        }

        if(is_numeric(trim($value))) {
            return 'ok';
        } else {
            return MAX_ERROR_RECORD_NON_INT;            
        }
    }
    
    return 'ok';    
}


/**
 * check if value have duplicated entires
 * @param string $variableName name of field 
 * @param string $value compared value
 * @param array $out array to compare with
 * @return bool 
 */
function isDuplicated($variableName, $value, &$out) {
    //check if variable should be unique 
    $res_variables = phpAds_dbQuery('SELECT is_unique, name FROM variables 
                                     WHERE name = \''.$variableName.'\' ');     
    $row_variables = phpAds_dbFetchArray($res_variables);

    if($row_variables['is_unique'] == 0) {
                return 0;
    }
    
    //check for duplicates in current result array
    foreach($out as $keyNum=>$record) {
        if($record['dynamic'][$variableName]['value'] == $value) {
            $duplicatedCount++;
        }
    }
    
    if($duplicatedCount > 1) {
        return 1;
    }
    return 0;

                   
}



// Register input variables
phpAds_registerGlobal('clients', 'campaigns', 'tracker');

//Set default values if exists
if (isset($clients)) {
    $GLOBALS['clients_defVal'] = $clients;    
}
if (isset($campaigns)) {
    $GLOBALS['campaigns_defVal'] = $campaigns;            
}
if (isset($tracker)) {
    $GLOBALS['tracker_defVal'] = $tracker;            
}

//fields to remove and default to empty
    $fieldsBlank = array(
                    "viewer_session_id", 
                    "creative_id", 
                    "tracker_ip_address", 
                    "connection_ip_address", 
                    "tracker_language", 
                    "connection_language", 
                    "tracker_host_name", 
                    "connection_host_name", 
                    "tracker_https", 
                    "connection_https", 
                    "tracker_domain", 
                    "connection_domain", 
                    "tracker_page", 
                    "connection_page", 
                    "tracker_query", 
                    "connection_query", 
                    "tracker_referer", 
                    "connection_referer", 
                    "tracker_search_term", 
                    "connection_search_term",
                    "tracker_country",
                    "tracker_os",
                    "tracker_browser",
                    "connection_user_agent",
                    "tracker_user_agent",
                    "server_raw_tracker_impression_id",
                    "viewer_id"
                    );

if(isset($GLOBALS['tracker_defVal']) && $GLOBALS['tracker_defVal'] != '') {  
    //prepare csv template data 
    $query = "SHOW COLUMNS FROM data_intermediate_ad_connection";
    $res_columns = phpAds_dbQuery($query) or phpAds_sqlDie();
  
    while ($row_columns = phpAds_dbFetchArray($res_columns)) {
        $columns[$row_columns['Field']] 	= $row_columns['Type'];
    }        

    //remove autoincrement field
    if(isset($columns['data_intermediate_ad_connection_id'])) {
        unset($columns['data_intermediate_ad_connection_id']);
    }
    //remove connection_date_time field - defaults to tracker_date_time's value
    if(isset($columns['connection_date_time'])) {
        unset($columns['connection_date_time']);
    }
    //remove updated field - defaults to 'now'
    if(isset($columns['updated'])) {
        unset($columns['updated']);
    }
    //remove server_raw_ip field - defaults to 'offline'
    if(isset($columns['server_raw_ip'])) {
        unset($columns['server_raw_ip']);
    }
    //remove tracker_id field - defaults to $tracker
    if(isset($columns['tracker_id'])) {
        unset($columns['tracker_id']);
    }
    
    if($_POST['country_info'] != true) {
        //remove connection_country field
        if(isset($columns['connection_country'])) {
            unset($columns['connection_country']);
        }
    }
   if($_POST['os_info'] != true) {
        //remove connection_os field 
        if(isset($columns['connection_os'])) {
            unset($columns['connection_os']);
        }
    }
   if($_POST['browser_info'] != true) {
        //remove connection_browser field
        if(isset($columns['connection_browser'])) {
            unset($columns['connection_browser']);
        }
    }
    
    // use array to remove unwanted vars
    foreach ($fieldsBlank as $val) {    
        //remove said fields
        if(isset($columns[$val])) {
            unset($columns[$val]);
        }        
    }
    
    //load additional fields
    $query = "SELECT name,datatype 
              FROM variables 
              WHERE trackerid = " . $GLOBALS['tracker_defVal'];

    $res_columns = phpAds_dbQuery($query) or phpAds_sqlDie();

    while ($row_columns = phpAds_dbFetchArray($res_columns)) {
        if ($row_columns['datatype'] == ''){
            $row_columns['datatype'] = 'string';
        }
        $columns[$row_columns['name']] 	        = $row_columns['datatype'];    
        $columns_static[$row_columns['name']] 	= $row_columns['datatype']; 
    }
  
    foreach($columns as $k => $v) {
        $stream .= '"'. $k . '"' . ",";
    }
    
}

//save array into db
if (isset($_POST['submitCommit'])) {

    phpAds_registerGlobal('out');
    $insertArray = unserialize(base64_decode($GLOBALS['out']));
    
    $clearToTest = array('connection_country'=>true,
                         'connection_browser'=>true,
                         'connection_os'=>true
                        );
    
    foreach($insertArray as $record) {
        foreach($record as $key=>$value) {
            unset($sql);
            unset($sqlNames);
            unset($sqlValues);       

            //load list of all varibles
            $res_variables = phpAds_dbQuery('SELECT variableid, name FROM variables');     
            while ($row_variables = phpAds_dbFetchArray($res_variables)) {
                $variablesArray[$row_variables['name']] 	= $row_variables['variableid'];
            }

            //static(field type) - insert into ad_connection, dynamic - ad_variable_value 
            if($key == 'static') {                            
                $sql = 'INSERT INTO data_intermediate_ad_connection ';
                foreach($value as $key1=>$value1) {
                    if (isset($clearToTest[$key1])) {
                        unset($clearToTest[$key1]);
                    }
                    if ($key1 == 'tracker_date_time') {
                        $connection_date_time = $value1['value'];   
                    }
                    $sqlNames  .= $key1 . ', ';
                    $sqlValues .= '\'' . $value1['value'] . '\'' . ', ';
                }
                $sqlNames  .= 'updated, ';
                $sqlValues .= '\'' . date('Y-m-d H:i:s') . '\'' . ', ';
                $sqlNames  .= 'connection_date_time, ';
                $sqlValues .= '\'' . $connection_date_time . '\'' . ', ';
                $sqlNames  .= 'server_raw_ip, ';
                $sqlValues .= '\'' . 'offline' . '\'' . ', ';
                $sqlNames  .= 'tracker_id, ';
                $sqlValues .= '\'' . $GLOBALS['_MAX']['PREF']['tracker'] . '\'' . ', ';
                
                // set clear options
                foreach($fieldsBlank as $blankV) {
                    $sqlNames  .= $blankV.', ';
                    $sqlValues .= '\'' . '' . '\'' . ', ';                    
                }
                // test whether to clear user info options
                foreach($clearToTest as $clearK=>$clearV) {
                    $sqlNames  .= $clearK.', ';
                    $sqlValues .= '\'' . '' . '\'' . ', ';                    
                }
                 
                $sqlNames = substr(trim($sqlNames), 0, strlen($sqlNames) -2 );        
                $sqlValues = substr(trim($sqlValues), 0, strlen($sqlValues) -2 );        
                $sql .= '(' . $sqlNames .')' . ' VALUES ' . '(' . $sqlValues . ')';
                
                if(!phpAds_dbQuery($sql)) {
                    $uploadError[] = MAX_ERROR_RECORD_WAS_NOT_INSERTED;
                } 

            }
            else if($key == 'dynamic') {                            
                $data_intermediate_ad_connection_id = phpAds_dbInsertID();
                              
                foreach($value as $key1=>$value1) {
                    $sql  = 'INSERT INTO data_intermediate_ad_variable_value ';
                    $sql .= '(data_intermediate_ad_connection_id, tracker_variable_id, value) VALUES ';
                    $sql .= '(\'' . $data_intermediate_ad_connection_id . '\', '; 
                    $sql .= '\'' . $variablesArray[$key1] . '\', ';
                    $sql .= '\'' . $value1['value'] . '\') ';
                    if(!phpAds_dbQuery($sql)) {
                        $uploadError[] = MAX_ERROR_RECORD_WAS_NOT_INSERTED;
                    } 

                }               

            }

       }
    }
    $flagUploaded = 1; 
}


//creating CVS template
if(isset($_POST['submitDisabled']) || isset($_POST['submitCreateTemplate'])) {

    if(isset($_POST['submitCreateTemplate'])) {
        $clientName = phpAds_getClientDetails($_POST['clients']);
        $clientName = str_replace(' ', '_', $clientName['clientname']);
        $campaignName = phpAds_getCampaignDetails($_POST['campaigns']);
        $campaignName = str_replace(' ', '_', $campaignName['campaignname']);
        $trackerName = phpAds_getTrackerDetails($_POST['tracker']);
        $trackerName = str_replace(' ', '_', $trackerName['trackername']);
        
        $csvFileName = $clientName . "__" . $trackerName . "__" . $campaignName . "__template";
        if(strlen($csvFileName) > 30) {
            $csvFileName = substr($csvFileName, 0, 30);
        }
        $csvFileName .= ".csv";
        downloadStream($stream,$csvFileName,'text/csv');
        die();
    }

    if(isset($_FILES['uploadedfile']) && !empty($_POST['start_upload'])) {
        $fp = fopen($_FILES['uploadedfile']['tmp_name'], "r");
        if($fp) {
            while( $temp = fgetcsv($fp, 10000, ',', '"') ) {
                  $line[] = $temp;
            }

            //spliting on static and user added fields
            foreach($line[0] as $key=>$value)
            {  
               
                if(trim($columns_static[$value]) == '') {
                    $status[$key]['status'] ='static';
                    $status[$key]['name']   = $value;
                } else { 
                    $status[$key]['status'] = 'dynamic'; 
                    $status[$key]['name']   = $value;
                } 
            }
        

            $requiredFields['ad_id'] = '0';
            $requiredFields['zone_id'] = '0';

            //check for required fileds
            foreach($status as $record)
                if($requiredFields[$record['name']] == '0')
                    $requiredFields[$record['name']] = 1;
            foreach($requiredFields as $key=>$value)
                if($value == '0') {
                  $uploadError[] = MAX_ERROR_MISSING_COLUMN_PART1 . 
                                   $key . MAX_ERROR_MISSING_COLUMN_PART2;
                }

            //check if loaded fields are allowed for selected tracker
            foreach($status as $record) {
                // exceptions to the rule: Country / OS / Browser
                $columnException = array (
                "connection_country" => 1,
                "connection_os" => 1,
                "connection_browser" => 1
                );
                if($columns[$record['name']] == '' && trim($record['name']) != '' && empty($columnException[$record['name']])) {
                    $uploadError[] = MAX_ERROR_WRONG_COLUMN_PART1 . 
                                     $record['name'] . MAX_ERROR_WRONG_COLUMN_PART2;
                }
            }


            //preparing records for display and split CVS data to static and user added fields
            unset($line[0]);
            $i=0;            
            foreach($line as $recK=>$record) {
                foreach($record as $key=>$value)
                { 
                    $value = trim($value);

                    //special rules for chosen fields 
                    if($status[$key]['name'] == 'updated')
                        $value = date('d/m/Y H:i'); 

                    if($status[$key]['name'] == 'server_raw_ip')
                        $value = 'offline';

                    if($status[$key]['name'] == 'connection_type' && trim($value) == '')
                        $value = $GLOBALS['_MAX']['PREF']['connection_type'];

                    if($status[$key]['name'] == 'connection_status' && trim($value) == '')
                        $value = $GLOBALS['_MAX']['PREF']['connection_status'];

                    if($status[$key]['name'] == 'connection_type' && !is_numeric($value)) {
                        $reversedDefaultConversionTypeList = array_flip($defaultConversionTypeList); 
                        $value = ucfirst(strtolower($value));
                        $value = $reversedDefaultConversionTypeList[$value];
                    }

                    if($status[$key]['name'] == 'connection_status' && !is_numeric($value)) {
                        $reversedDefaultConversionStatusList = array_flip($defaultConversionStatusList); 
                        $value = ucfirst(strtolower($value));                   
                        $value = $reversedDefaultConversionStatusList[$value];
                    }

                    if($status[$key]['status']=='static' && trim($status[$key]['name']) != '') {
                        $out[$i]['static'][$status[$key]['name']]['value'] = $value;
                        $out[$i]['static'][$status[$key]['name']]['validate'] = validateCsvData($value,$columns[$status[$key]['name']]); 
                        if($out[$i]['static'][$status[$key]['name']]['validate'] != 'ok') {

                            //if field type datetime not valid try to reformat date
                            if($out[$i]['static'][$status[$key]['name']]['validate'] == 'datetime') {
                                  if($tmpVal = date( "Y-m-d H:i:s", strtotime($value))) {
                                      $out[$i]['static'][$status[$key]['name']]['value'] = $tmpVal;
                                      $out[$i]['static'][$status[$key]['name']]['validate'] = 'ok';
                                  }
                                  else {
                                      $out[$i]['static'][$status[$key]['name']]['validate'] = MAX_ERROR_WRONG_DATE_FORMAT;
                                      $brokenRecordsCount[] = 1;
                                  }
                               
                            } else {
                                $brokenRecordsCount[] = 1;
                            } 
                        }
                    }
                    else if($status[$key]['status']=='dynamic' && trim($status[$key]['name']) != '') {  
                        $out[$i]['dynamic'][$status[$key]['name']]['value'] = $value;
                        if(isDuplicated($status[$key]['name'], $value, &$out) == 0) {
                            $out[$i]['dynamic'][$status[$key]['name']]['validate'] = validateCsvData($value,$columns[$status[$key]['name']]); 
                        } else {
                            $out[$i]['dynamic'][$status[$key]['name']]['validate'] = MAX_ERROR_DUPLICATED_VALUE; 
                        }
                        if($out[$i]['dynamic'][$status[$key]['name']]['validate'] != 'ok') {
                            $brokenRecordsCount[] = 1; 
                        }
                    }
                }
                $i++;                        
            } //foreach end
        } //if($fp) end
    
    } 

}


phpAds_PrepareHelp();
if (phpAds_isUser(phpAds_Admin)) {
    phpAds_PageHeader("5.1");
    phpAds_ShowSections(array("5.1", "5.3", "5.4", "5.2", "5.5", "5.6"));
} elseif (phpAds_isUser(phpAds_Agency)) {
    phpAds_PageHeader("5.1");
    phpAds_ShowSections(array("5.1", "5.2"));
} else {
    phpAds_PageHeader("4.1");
    phpAds_ShowSections(array("4.1"));
}
phpAds_SettingsSelection("csvimport");

$admin_settings = phpAds_isUser(phpAds_Admin) || phpAds_isUser(phpAds_Agency);



//prepare data for select fields
//clients
$res_clients = phpAds_dbQuery(
    "SELECT clientid,clientname".
    " FROM ".$conf['table']['prefix'].$conf['table']['clients'].
    " WHERE agencyid=".phpAds_getUserID().
    phpAds_getClientListOrder ($listorder, $orderdirection)
) or phpAds_sqlDie();

unset($clients);
while ($row_clients = phpAds_dbFetchArray($res_clients)) {
    $clients[$row_clients['clientid']] 	= $row_clients['clientname'];
}


//campaign
$query = "SELECT campaignid,campaignname".
         " FROM ".$conf['table']['prefix'].$conf['table']['campaigns'];

if (isset($_POST['clients']) && $_POST['clients'] != '') {
    $query .= " WHERE clientid=".$_POST['clients'];
} else {
    $query .= " WHERE clientid=".phpAds_getUserID();
}

$res_campaigns = phpAds_dbQuery($query) or phpAds_sqlDie();
unset($campaigns);

while ($row_campaigns = phpAds_dbFetchArray($res_campaigns)) {
    $campaigns[$row_campaigns['campaignid']] 	= $row_campaigns['campaignname'];
}

//tracker
$query = "SELECT trackerid,trackername".
         " FROM ".$conf['table']['prefix'].$conf['table']['trackers'];

if (isset($_POST['clients']) && $_POST['clients'] != '') {
    $query .= " WHERE clientid=".$_POST['clients'];
} else {
    reset($clients);
    $query .= " WHERE clientid=".key($clients);
}

$res_trackers = phpAds_dbQuery($query) or phpAds_sqlDie();
unset($trackers);

while ($row_trackers = phpAds_dbFetchArray($res_trackers)) {
    $trackers[$row_trackers['trackerid']] 	= $row_trackers['trackername'];
}


//default value for selects
$GLOBALS['default_conversion_status'] = MAX_CONNECTION_STATUS_APPROVED;
$GLOBALS['connection_type_defVal'] = 4;


if(count($trackers)==0) {
    $settings = array (
         array (
            'text'  => $strUploadConversions,
            'items' => array (
                array (
                    'type'  => 'select',
                    'name'  => 'clients',
                    'text'  => $strChooseAdvertiser,
                    'items' => $clients,
                    'visible' => $admin_settings
                ),
            )
        )
    );

    $errormessage[0] = MAX_ERROR_YOU_HAVE_NO_TRACKERS;
    $var = phpAds_ShowSettings($settings, $errormessage, $disableSubmit=1);

} else {
    $settings = array (
         array (
            'text'  => $strUploadConversions,
            'items' => array (
                array (
                    'type'  => 'select',
                    'name'  => 'clients',
                    'text'  => $strChooseAdvertiser,
                    'items' => $clients,
                    'visible' => $admin_settings
                ),
                array (
                    'type'  => 'break',
                    'visible' => $admin_settings
                ),
                array (
                    'type'  => 'select',
                    'name'  => 'campaigns',
                    'text'  => $strChooseCampaign,
                    'items' => $campaigns,
                    'visible' => $admin_settings
                ),                
                array (
                    'type'  => 'break',
                    'visible' => $admin_settings
                ),
                array (
                    'type'  => 'select',
                    'name'  => 'tracker',
                    'text'  => $strChooseTracker,
                    'items' => $trackers,
                    'visible' => $admin_settings
                ),
                array (
                    'type'  => 'break',
                    'visible' => $admin_settings
                ),
                array (
                    'type'  => 'select',
                    'name'  => 'connection_status',
                    'text'  => $strDefaultConversionStatus,
                    'items' => $defaultConversionStatusList,
                    'value' => $default_conversion_status,
                    'visible' => $admin_settings,
                    'reload'  => 'no'
                ),
                array (
                    'type'  => 'break',
                    'visible' => $admin_settings
                ),
                array (
                    'type'  => 'select',
                    'name'  => 'connection_type',
                    'text'  => $strDefaultConversionType,
                    'items' => $defaultConversionTypeList,
                    'visible' => $admin_settings,
                    'reload'  => 'no'
                ),
                array (
                    'type'  => 'break',
                    'visible' => $admin_settings
                ),
                array (
                    'type'  => 'checkbox',
                    'name'  => 'country_info',
                    'text'  => MAX_INFO_COUNTRY,
                    'visible' => $admin_settings
                ),
                array (
                    'type'  => 'checkbox',
                    'name'  => 'os_info',
                    'text'  => MAX_INFO_OS,
                    'visible' => $admin_settings
                ),
                array (
                    'type'  => 'checkbox',
                    'name'  => 'browser_info',
                    'text'  => MAX_INFO_BROWSER,
                    'visible' => $admin_settings
                )

            )
        )
    );
    





    if(isset($_FILES['uploadedfile']) && $_FILES['uploadedfile']['size'] > 0  && !empty($_POST['start_upload'])) {

        //show errors
        if(isset($uploadError) && count($uploadError) > 0) {
            foreach($uploadError as $record) {
                echo $record;
            }
        } else {
            //show basic information
            echo "<strong>" . MAX_INFO_LOADED_RECORDS . "</strong>: " . count($out) . '<br />';
            echo "<strong>" . MAX_INFO_BROKEN_RECORDS . "</strong>: " .count($brokenRecordsCount) . '<br />';
            
            echo '<br /><br />';

            //display table header
            echo '<table border="0" cellpadding="0" cellspacing="0"> <thead><tr>';
            foreach($out as $record) {
                foreach($record as $key=>$value) {
                    foreach($value as $key1=>$value1) {
                        echo '<td align="center" style="padding-left: 15px;padding-right: 15px;" >' . $key1 . ' ' . '</td>';
                    }
                }
                echo '</thead><tr>';
                break;
            }
            $i=0;
            //display table data
            foreach($out as $record) {
                foreach($record as $key=>$value) {
                    foreach($value as $key1=>$value1) {
                        echo '<td height="25" style="padding-left: 15px;padding-right: 15px;" align="left"';
                        if($value1['validate'] != 'ok') {
                            echo ' bgcolor="pink"';
                        }
                        echo '>';
                        if($value1['validate'] == 'ok') {
                            echo '<font color="#333333">';
                        }
                        echo $value1['value'];
                        if($value1['validate'] != 'ok') {
                            echo '<br> <font class="csverror">' . $value1['validate'] . '</font>';
                        }
                        if($value1['validate'] == 'ok') {
                            echo '</font>';
                        }
                        echo '</td>';

                    }
                }
                echo '</tr>';
                echo "<tr height='1'>
					      <td colspan='100' height='1' bgcolor='#888888'><img src='images/break.gif' height='1' width='100%'></td>
				      </tr>";
                echo "<tr ".($i%2==0?"bgcolor='#F6F6F6'":"").">";
                $i++;
            }

            echo '</tr> </table>';

            echo '<form method="post" action="?">';
            echo '<input type="hidden" name="out" value="'. base64_encode(serialize($out)) .'">';
            echo '<input type="hidden" name="clients" value="'.$_POST['clients'].'">';
            echo '<input type="hidden" name="campaigns" value="'.$_POST['campaigns'].'">'; 
            echo '<input type="hidden" name="tracker" value="'.$_POST['tracker'].'">';       
            echo '<input type="hidden" name="default_conversion_status" value="'.$_POST['default_conversion_status'].'">';
            echo '<input type="hidden" name="default_conversion_type" value="'.$_POST['default_conversion_type'].'">';
            echo '<input type="hidden" name="submitCommit" value="1">';
            echo '<table border="0"><tr>';
            echo '<td> <br> <input type="submit" name="submit1" value="'.MAX_INFO_CONFIRM_UPLOAD.'"> </td>';
            echo '</tr></table>';
            echo '</form>';

            echo '<form method="post" action="?">';
            echo '<input type="hidden" name="clients" value="'.$_POST['clients'].'">';
            echo '<input type="hidden" name="campaigns" value="'.$_POST['campaigns'].'">'; 
            echo '<input type="hidden" name="tracker" value="'.$_POST['tracker'].'">';       
            echo '<input type="hidden" name="default_conversion_status" value="'.$_POST['default_conversion_status'].'">';
            echo '<input type="hidden" name="default_conversion_type" value="'.$_POST['default_conversion_type'].'">';
            echo '<table border="0"><tr>';
            echo '<td> <br> <input type="submit" name="" value="'.MAX_INFO_REUPLOAD_CSV_FILE.'"> </td>';
            echo '</tr></table>';
        } //endif (showErros)

    } else {
  
        $conf['max']['installed']=0;

        if(isset($flagUploaded) && $flagUploaded == 1) {
            if(isset($uploadError) && count($uploadError) > 0) {
                echo MAX_ERROR_INSERT_ERROR_PART1 . count($uploadError) . MAX_ERROR_INSERT_ERROR_PART2;
            } else {
                echo MAX_INFO_INSERT_CORRECT;
            }
        }    

        //show errors
        if(isset($uploadError) && count($uploadError) > 0) {
            foreach($uploadError as $record) {
                echo $record;
            }
        } else { 
            $var = phpAds_ShowSettings($settings, $errormessage, $disableSubmit=1);
        }
    }
}  //end if

phpAds_PageFooter();

?>
